.\"	$FreeBSD: src/usr.sbin/rtadvd/rtadvd.8,v 1.3.2.8 2003/03/11 22:31:32 trhodes Exp $
.\"	$DragonFly: src/usr.sbin/rtadvd/rtadvd.8,v 1.4 2007/11/23 23:16:37 swildner Exp $
.\"	$KAME: rtadvd.8,v 1.17 2001/02/04 05:34:38 jinmei Exp $
.\"
.\" Copyright (C) 1995, 1996, 1997, and 1998 WIDE Project.
.\" All rights reserved.
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in the
.\"    documentation and/or other materials provided with the distribution.
.\" 3. Neither the name of the project nor the names of its contributors
.\"    may be used to endorse or promote products derived from this software
.\"    without specific prior written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE PROJECT AND CONTRIBUTORS ``AS IS'' AND
.\" ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
.\" IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE PROJECT OR CONTRIBUTORS BE LIABLE
.\" FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
.\" OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
.\" HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
.\" LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
.\" OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
.\" SUCH DAMAGE.
.\"
.Dd May 17, 1998
.Dt RTADVD 8
.Os
.Sh NAME
.Nm rtadvd
.Nd router advertisement daemon
.Sh SYNOPSIS
.Nm
.Op Fl dDfMRs
.Op Fl c Ar configfile
.Ar interface ...
.Sh DESCRIPTION
The
.Nm
utility sends router advertisement packets to the specified
.Ar interfaces .
.Pp
The program will daemonize itself on invocation.
It will then send router advertisement packets periodically, as well
as in response to router solicitation messages sent by end hosts.
.Pp
Router advertisements can be configured on a per-interface basis, as
described in
.Xr rtadvd.conf 5 .
.Pp
If there is no configuration file entry for an interface,
or if the configuration file does not exist altogether,
.Nm
sets all the parameters to their default values.
In particular,
.Nm
reads all the interface routes from the routing table and advertises
them as on-link prefixes.
.Pp
The
.Nm
utility also watches the routing table.
If an interface direct route is
added on an advertising interface and no static prefixes are
specified by the configuration file,
.Nm
adds the corresponding prefix to its advertising list.
.Pp
Similarly, when an interface direct route is deleted,
.Nm
will start advertising the prefixes with zero valid and preferred
lifetimes to help the receiving hosts switch to a new prefix when
renumbering.
Note, however, that the zero valid lifetime cannot invalidate the
autoconfigured addresses at a receiving host immediately.
According to the specification, the host will retain the address
for a certain period, which will typically be two hours.
The zero lifetimes rather intend to make the address deprecated,
indicating that a new non-deprecated address should be used as the
source address of a new connection.
This behavior will last for two hours.
Then
.Nm
will completely remove the prefix from the advertising list,
and succeeding advertisements will not contain the prefix information.
.Pp
Moreover, if the status of an advertising interface changes,
.Nm
will start or stop sending router advertisements according
to the latest status.
.Pp
The
.Fl s
option may be used to disable this behavior;
.Nm
will not watch the routing table and the whole functionality described
above will be suppressed.
.Pp
Basically, hosts MUST NOT send Router Advertisement messages at any
time (RFC 2461, Section 6.2.3).
However, it would sometimes be useful to allow hosts to advertise some
parameters such as prefix information and link MTU.
Thus,
.Nm
can be invoked if router lifetime is explicitly set zero on every
advertising interface.
.Pp
The command line options are:
.Bl -tag -width indent
.\"
.It Fl c
Specify an alternate location,
.Ar configfile ,
for the configuration file.
By default,
.Pa /etc/rtadvd.conf
is used.
.It Fl d
Print debugging information.
.It Fl D
Even more debugging information is printed.
.It Fl f
Foreground mode (useful when debugging).
.It Fl M
Specify an interface to join the all-routers site-local multicast group.
By default,
.Nm
tries to join the first advertising interface appeared in the command
line.
This option has meaning only with the
.Fl R
option, which enables routing renumbering protocol support.
.\".It Fl m
.\"Enables mobile IPv6 support.
.\"This changes the content of router advertisement option, as well as
.\"permitted configuration directives.
.It Fl R
Accept router renumbering requests.
If you enable it, certain IPsec setup is suggested for security reasons.
On KAME-based systems,
.Xr rrenumd 8
generates router renumbering request packets.
This option is currently disabled, and is ignored by
.Nm
with a warning message.
.It Fl s
Do not add or delete prefixes dynamically.
Only statically configured prefixes, if any, will be advertised.
.El
.Pp
Upon receipt of signal
.Dv SIGUSR1 ,
.Nm
will dump the current internal state into
.Pa /var/run/rtadvd.dump .
.Pp
Use
.Dv SIGTERM
to kill
.Nm
gracefully.
In this case,
.Nm
will transmit router advertisement with router lifetime 0
to all the interfaces
(in accordance with RFC 2461 6.2.5).
.Sh FILES
.Bl -tag -width Pa -compact
.It Pa /etc/rtadvd.conf
The default configuration file.
.It Pa /var/run/rtadvd.pid
contains the pid of the currently running
.Nm .
.It Pa /var/run/rtadvd.dump
in which
.Nm
dumps its internal state.
.El
.Sh DIAGNOSTICS
.Ex -std
.Sh SEE ALSO
.Xr rtadvd.conf 5 ,
.Xr rrenumd 8 ,
.Xr rtsol 8
.Sh HISTORY
The
.Nm
utility first appeared in WIDE Hydrangea IPv6 protocol stack kit.
.Sh CAVEAT
There used to be some text that recommended users not to let
.Nm
advertise Router Advertisement messages on an upstream link to avoid
undesirable
.Xr icmp6 4
redirect messages.
However, based on the later discussion in the IETF ipng working group,
all routers should rather advertise the messages regardless of
the network topology, in order to ensure reachability.
